﻿//
// Copyright (c) 2015, MindFusion LLC - Bulgaria.
//

using System;
using System.Windows;
using System.Windows.Data;
using System.Windows.Media;


namespace MindFusion.Reporting.Wpf.Samples.CS.PieCharts
{
	public class IndexToBrushConverter : DependencyObject, IValueConverter
	{
		public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			if (!(value is int))
				return System.Windows.Media.Brushes.White;

			int index = (int)value - 1;
			if (index < 0 || index >= Brushes.Length)
				return System.Windows.Media.Brushes.White;

			return Brushes[index];
		}

		public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			throw new NotImplementedException();
		}

		public Brush[] Brushes
		{
			get { return GetValue(BrushesProperty) as Brush[]; }
			set { SetValue(BrushesProperty, value); }
		}

		public static readonly DependencyProperty BrushesProperty =
			DependencyProperty.Register("Brushes", typeof(Brush[]), typeof(IndexToBrushConverter));
	}
}
